AC_DEFUN([MYSQL_CHECK],
[
  MYSQL_CFLAGS=""
  MYSQL_LIBS="-lmysqlclient"

  OLD_CFLAGS=$CFLAGS
  OLD_LIBS=$LIBS
  CFLAGS="$CFLAGS $MYSQL_CFLAGS"
  LIBS="$LIBS $MYSQL_LIBS"

  AC_CHECK_LIB([mysqlclient], [mysql_init],, MYSQL_ERROR)
  AC_MSG_CHECKING([for the MySQL client library])
  AC_TRY_LINK(
  [
    #include <mysql/mysql.h>
    #include <mysql/errmsg.h>
  ],
  [
    MYSQL *m;
    m = mysql_init(0);
  ],
  [
    AC_MSG_RESULT([yes])
    AC_SUBST(MYSQL_CFLAGS)
    AC_SUBST(MYSQL_LIBS)
  ],
  [
    AC_MSG_RESULT([no])
    MYSQL_ERROR
  ])

  CFLAGS=$OLD_CFLAGS
  LIBS=$OLD_LIBS
])

AC_DEFUN([MYSQL_ERROR],
[
  AC_MSG_ERROR([$PACKAGE requires the MySQL client library development package
])
])
