#ifndef ADHIC_H
#define ADHIC_H

#include"constants.h"
#include"protocol.h"
#include<pcap.h>

typedef struct png
{
    int         offset;
    u_char*     val;
    int         match;
#ifdef VARIABLE_N
    int         length;
#endif
} png_t;

typedef struct png_op           // png operator
{
    int         png_size;
    png_t*      pngs[MAX_PNGS];
} png_op_t;

typedef struct queue
{
    p_stats     stats_total;
    p_stats     stats[MAX_TIME];   
} queue_t;

typedef struct node
{
    union
    {
        png_op_t    pngs;
        queue_t     queue;
    } data;
    int             id;
    int             type;
    int             count_cache[MAX_TIME];
    struct node*    left;
    struct node*    right;
    struct node*    parent;
    int             born;
    int             monitor;
    boolean         frozen;

    int             db_id;
} node_t;

#endif // ADHIC_H
