#ifndef FLOW_H
#include<stdio.h>
#include<pcap.h>
//#include"hashtable.h"
#include"constants.h"

typedef struct flow
{
    u_char  protocol;
    u_int   src;
    u_int   dst;
    u_short src_port;
    u_short dst_port;
} flow_t;

boolean flow_eq(void* val1, void* val2);
void flow_add(flow_t* flow);
void flow_remove(flow_t* flow);
flow_t* flow_zero();
flow_t* flow_from_file(FILE* file);
flow_t* flow_from_packet(const u_char* packet, unsigned int len);
flow_t* flow_from_string(char* string);
boolean flow_match(flow_t* flow, const u_char* packet, unsigned int len);
//void dict_flow_packet_add(hashtable_t* table, qcap_packet_t* packet);
//int dict_flow_print(FILE* file, hashtable_t* table);
boolean flow_matches(const u_char* packet, unsigned int len);
flow_t* flow_new(int protocol, int src, int dst, int src_port, int dst_port);
void flow_print(FILE* file, flow_t* flow);


#endif // FLOW_H
