#include"protocol.h"
#include"constants.h"
#include"sim.h"
#include<stdlib.h>
#include<glib.h>

static p_stats_names* names = NULL;
static p_stats_names* dbnms = NULL;


void p_stats_names_init()
{
    names = g_new0(p_stats_names, 1);
    dbnms = g_new0(p_stats_names, 1); /* leave null for the ones that don't
                                         have a corresponding table column */

    names->ether_names[ETHER_UNKNOWN_E] = "Ether Unknown";
    dbnms->ether_names[ETHER_UNKNOWN_E] = "ether";
    names->ether_names[MPLSuni_E]       = "MPLS uni";
    dbnms->ether_names[MPLSuni_E]       = "ether_mpls_uni";
    names->ether_names[MPLSmulti_E]     = "MPLS multi";
    dbnms->ether_names[MPLSmulti_E]     = "ether_mpls_multi";
    names->ether_names[PPPoEdisc_E]     = "PPPoEdisc";
    dbnms->ether_names[PPPoEdisc_E]     = "ether_pppoe_disc";
    names->ether_names[PPPoEss_E]       = "PPPoEss";
    dbnms->ether_names[PPPoEss_E]       = "ether_pppoe_ss";
    names->ether_names[ETHER_EXCEPTION_1_E] = "Ether Exception 1";
    dbnms->ether_names[ETHER_EXCEPTION_1_E] = "ether_exception_1";
    names->ether_names[LOOP_E]          = "LOOP";
    dbnms->ether_names[LOOP_E]          = "ether_loop";
    names->ether_names[IPv4_E]          = "IPv4";
    names->ether_names[ARP_E]           = "ARP";
    dbnms->ether_names[ARP_E]           = "ether_arp";
    names->ether_names[RARP_E]          = "RARP";
    dbnms->ether_names[RARP_E]          = "ether_rarp";
    names->ether_names[ETHERTALK_E]     = "Ethertalk";
    dbnms->ether_names[ETHERTALK_E]     = "ether_ethertalk";
    names->ether_names[AARP_E]          = "AARP";
    dbnms->ether_names[AARP_E]          = "ether_aarp";
    names->ether_names[IEEE8021Q_E]     = "IEEE 802.1Q";
    dbnms->ether_names[IEEE8021Q_E]     = "ether_802_1q";
    names->ether_names[IPX_E]           = "IPX";
    dbnms->ether_names[IPX_E]           = "ether_ipx";
    names->ether_names[NOVELL_E]        = "NOVELL";
    dbnms->ether_names[NOVELL_E]        = "ether_novell";
    names->ether_names[IPv6_E]          = "IPv6";
    dbnms->ether_names[IPv6_E]          = "ether_ipv6";
    names->ether_names[ATAoE_E]         = "ATAoE";
    dbnms->ether_names[ATAoE_E]         = "ether_ataoe";
    names->ether_names[ETHER_E]         = "ETHER (old)";
    dbnms->ether_names[ETHER_E]         = "ether_ether_old";
    names->ether_names[ETHER_DUMMY_1_E] = "";
    names->ether_names[ETHER_DUMMY_2_E] = "";
    names->ether_names[ETHER_DUMMY_3_E] = "";
    names->ether_names[ETHER_DUMMY_4_E] = "";
    names->ether_names[ETHER_DUMMY_5_E] = "";
    names->ether_names[ETHER_DUMMY_6_E] = "";
    names->ether_names[ETHER_DUMMY_7_E] = "";
    names->ether_names[ETHER_DUMMY_8_E] = "";
    names->ether_names[ETHER_DUMMY_9_E] = "";
    names->ether_names[ETHER_DUMMY_10_E] = "";
    names->ether_names[ETHER_DUMMY_11_E] = "";
    names->ether_names[ETHER_DUMMY_12_E] = "";

    names->ip_names[IP_UNKNOWN_E]       = "IP Unknown";
    dbnms->ip_names[IP_UNKNOWN_E]       = "ether_ipv4";
    names->ip_names[ICMP_E]             = "ICMP";
    dbnms->ip_names[ICMP_E]             = "ether_ipv4_icmp";
    names->ip_names[IGMP_E]             = "IGMP";
    dbnms->ip_names[IGMP_E]             = "ether_ipv4_igmp";
    names->ip_names[TCP_E]              = "TCP";
    names->ip_names[UDP_E]              = "UDP";
    names->ip_names[EIGRP_E]            = "EIGRP";
    dbnms->ip_names[EIGRP_E]            = "ether_ipv4_eigrp";
    names->ip_names[IP_DUMMY_1_E]       = "";
    names->ip_names[IP_DUMMY_2_E]       = "";
    names->ip_names[IP_DUMMY_3_E]       = "";
    names->ip_names[IP_DUMMY_4_E]       = "";
    names->ip_names[IP_DUMMY_5_E]       = "";
    names->ip_names[IP_DUMMY_6_E]       = "";
    names->ip_names[IP_DUMMY_7_E]       = "";
    names->ip_names[IP_DUMMY_8_E]       = "";
    names->ip_names[IP_DUMMY_9_E]       = "";
    names->ip_names[IP_DUMMY_10_E]       = "";
    names->ip_names[IP_DUMMY_11_E]       = "";
    names->ip_names[IP_DUMMY_12_E]       = "";
    names->ip_names[IP_DUMMY_13_E]       = "";
    names->ip_names[IP_DUMMY_14_E]       = "";
    names->ip_names[IP_DUMMY_15_E]       = "";
    names->ip_names[IP_DUMMY_16_E]       = "";
    names->ip_names[IP_DUMMY_17_E]       = "";
    names->ip_names[IP_DUMMY_18_E]       = "";
    names->ip_names[IP_DUMMY_19_E]       = "";
    names->ip_names[IP_DUMMY_20_E]       = "";
    names->ip_names[IP_DUMMY_21_E]       = "";
    names->ip_names[IP_DUMMY_22_E]       = "";
    names->ip_names[IP_DUMMY_23_E]       = "";
    names->ip_names[IP_DUMMY_24_E]       = "";
    
    names->udp_names[HSRP_E]            = "HSRP";
    dbnms->udp_names[HSRP_E]            = "ether_ipv4_udp_hsrp";
    names->udp_names[WHO_E]             = "WHO";
    dbnms->udp_names[WHO_E]             = "ether_ipv4_udp_who";
    names->udp_names[SRVLOC_E]          = "SRVLOC";
    dbnms->udp_names[SRVLOC_E]          = "ether_ipv4_udp_srvloc";
    names->udp_names[SNMP_E]            = "SNMP";
    dbnms->udp_names[SNMP_E]            = "ether_ipv4_udp_snmp";
    names->udp_names[RIPv1_E]           = "RIPv1";
    dbnms->udp_names[RIPv1_E]           = "ether_ipv4_udp_rip_v1";
    names->udp_names[NBNS_E]            = "NBNS";
    dbnms->udp_names[NBNS_E]            = "ether_ipv4_udp_nbns";
    names->udp_names[NETBIOS_DGM_E]     = "NBDGM";
    dbnms->udp_names[NETBIOS_DGM_E]     = "ether_ipv4_udp_nbdgm";
    names->udp_names[MSFT_MS_E]         = "DCE_RPC";
    dbnms->udp_names[MSFT_MS_E]         = "ether_ipv4_udp_dce_rpc";
    names->udp_names[MSFT_SQL_E]        = "MS SQL";
    dbnms->udp_names[MSFT_SQL_E]        = "ether_ipv4_udp_ms_sql";
    names->udp_names[UDP_DNS_E]         = "DNS";
    dbnms->udp_names[UDP_DNS_E]         = "ether_ipv4_udp_dns";
    names->udp_names[NTP_E]             = "NTP";
    dbnms->udp_names[NTP_E]             = "ether_ipv4_udp_ntp";
    names->udp_names[DHCP_E]            = "DHCP";
    dbnms->udp_names[DHCP_E]            = "ether_ipv4_udp_dhcp";
    names->udp_names[MDNS_E]            = "MDNS";
    dbnms->udp_names[MDNS_E]            = "ether_ipv4_udp_mdns";
    names->udp_names[RTP_E]             = "RTP";
    dbnms->udp_names[RTP_E]             = "ether_ipv4_udp_rtp";
    names->udp_names[CUPS_E]            = "CUPS";
    dbnms->udp_names[CUPS_E]            = "ether_ipv4_udp_cups";
    names->udp_names[XDMCP_E]           = "XDMCP";
    dbnms->udp_names[XDMCP_E]           = "ether_ipv4_udp_xdmcp";
    names->udp_names[BITTORRENT_E]      = "Bit Torrent";
    dbnms->udp_names[BITTORRENT_E]      = "ether_ipv4_udp_torrent";
    names->udp_names[GANGLIA_E]         = "Ganglia";
    dbnms->udp_names[GANGLIA_E]         = "ether_ipv4_udp_ganglia";
    names->udp_names[IPSEC_E]           = "IPSec";
    dbnms->udp_names[IPSEC_E]           = "ether_ipv4_udp_ipsec";
    names->udp_names[UDP_UNKNOWN_E]     = "UDP Unknown";
    dbnms->udp_names[UDP_UNKNOWN_E]     = "ether_ipv4_udp";
    names->udp_names[UDP_DUMMY_1_E]     = "";
    names->udp_names[UDP_DUMMY_2_E]     = "";
    names->udp_names[UDP_DUMMY_3_E]     = "";
    names->udp_names[UDP_DUMMY_4_E]     = "";
    names->udp_names[UDP_DUMMY_5_E]     = "";
    names->udp_names[UDP_DUMMY_6_E]     = "";
    names->udp_names[UDP_DUMMY_7_E]     = "";
    names->udp_names[UDP_DUMMY_8_E]     = "";
    names->udp_names[UDP_DUMMY_9_E]     = "";
    names->udp_names[UDP_DUMMY_10_E]    = "";
    
    names->tcp_names[HTTP_E]            = "HTTP";
    dbnms->tcp_names[HTTP_E]            = "ether_ipv4_tcp_http";
    names->tcp_names[HTTPS_E]           = "HTTPS";
    dbnms->tcp_names[HTTPS_E]           = "ether_ipv4_tcp_https";
    names->tcp_names[TELNET_E]          = "TELNET";
    dbnms->tcp_names[TELNET_E]          = "ether_ipv4_tcp_telnet";
    names->tcp_names[IMAP_E]            = "IMAP";
    dbnms->tcp_names[IMAP_E]            = "ether_ipv4_tcp_imap";
    names->tcp_names[IMAPS_E]           = "IMAPS";
    dbnms->tcp_names[IMAPS_E]           = "ether_ipv4_tcp_imaps";
    names->tcp_names[SMTP_E]            = "SMTP";
    dbnms->tcp_names[SMTP_E]            = "ether_ipv4_tcp_smtp";
    names->tcp_names[IPP_E]             = "IPP";
    dbnms->tcp_names[IPP_E]             = "ether_ipv4_tcp_ipp";
    names->tcp_names[NBSS_E]            = "NBSS";
    dbnms->tcp_names[NBSS_E]            = "ether_ipv4_tcp_nbss";
    names->tcp_names[SSH_E]             = "SSH";
    dbnms->tcp_names[SSH_E]             = "ether_ipv4_tcp_ssh";
    names->tcp_names[POP_E]             = "POP";
    dbnms->tcp_names[POP_E]             = "ether_ipv4_tcp_pop";
    names->tcp_names[POPS_E]            = "POPS";
    dbnms->tcp_names[POPS_E]            = "ether_ipv4_tcp_pops";
    names->tcp_names[MSNMS_E]           = "MSNMS";
    dbnms->tcp_names[MSNMS_E]           = "ether_ipv4_tcp_msnms";
    names->tcp_names[SMB_E]             = "SMB";
    dbnms->tcp_names[SMB_E]             = "ether_ipv4_tcp_smb";
    names->tcp_names[TCP_DNS_E]         = "DNS";
    dbnms->tcp_names[TCP_DNS_E]         = "ether_ipv4_tcp_dns";
    names->tcp_names[FTP_E]             = "FTP";
    dbnms->tcp_names[FTP_E]             = "ether_ipv4_tcp_ftp";
    names->tcp_names[RTSP_E]            = "RTSP";
    dbnms->tcp_names[RTSP_E]            = "ether_ipv4_tcp_rtsp";
    names->tcp_names[IRC_E]             = "IRC";
    dbnms->tcp_names[IRC_E]             = "ether_ipv4_tcp_irc";
    names->tcp_names[MYSQL_E]           = "MYSQL";
    dbnms->tcp_names[MYSQL_E]           = "ether_ipv4_tcp_mysql";
    names->tcp_names[NNTP_E]            = "NNTP";
    dbnms->tcp_names[NNTP_E]            = "ether_ipv4_tcp_nntp";
//    names->tcp_names[SUNRPC_E]          = "SUNRPC";
    names->tcp_names[DCE_RPC_E]         = "DCE_RPC";
    dbnms->tcp_names[DCE_RPC_E]         = "ether_ipv4_tcp_dce_rpc";
    names->tcp_names[XMPP_E]            = "XMPP";
    dbnms->tcp_names[XMPP_E]            = "ether_ipv4_tcp_xmpp";
    names->tcp_names[TCP_SPECIAL_LEN_E] = "TCP No Payload";
    dbnms->tcp_names[TCP_SPECIAL_LEN_E] = "ether_ipv4_tcp_no_payload";
    names->tcp_names[TCP_SOPHOS_E]      = "TCP Sophos";
    dbnms->tcp_names[TCP_SOPHOS_E]      = "ether_ipv4_tcp_tcp_sophos";
    names->tcp_names[MS_STREAMING_E]    = "MS Streaming";
    dbnms->tcp_names[MS_STREAMING_E]    = "ether_ipv4_tcp_ms_streaming";
    names->tcp_names[URD_E]             = "URD";
    dbnms->tcp_names[URD_E]             = "ether_ipv4_tcp_urd";
    names->tcp_names[CVS_E]             = "CVS";
    dbnms->tcp_names[CVS_E]             = "ether_ipv4_tcp_cvs";
    names->tcp_names[TCP_UNKNOWN_E]     = "TCP Unknown";  
    dbnms->tcp_names[TCP_UNKNOWN_E]     = "ether_ipv4_tcp";
    names->tcp_names[MSFT_WBT_E]        = "MS WBT";
    dbnms->tcp_names[MSFT_WBT_E]        = "ether_ipv4_tcp_ms_wbt";
    names->tcp_names[TCP_DUMMY_1_E]     = "";
    names->tcp_names[TCP_DUMMY_2_E]     = "";
}

p_stats_names* p_stats_get_db_names() { return dbnms; }

unsigned short ip_total_length(const u_char* packet, unsigned int len)
{
    assert(isIPv4(packet, len));
    unsigned short ret = packet[ip_offset+2] << 8 | packet[ip_offset+3];
    return ret;
}

unsigned short ip_header_length(const u_char* packet, unsigned int len)
{
    assert(isIPv4(packet, len));
    unsigned short ret = (packet[ip_offset+0] & 0x0F) * 4; 
    return ret;
}

unsigned short tcp_header_length(const u_char* packet, unsigned int len)
{
    assert(isIPv4(packet, len));
    int header_length = (packet[ip_offset+0] & 0x0F) * 4; //mask byte 15 with 0x0F to get header length; words * word_length
    unsigned short ret = ((packet[ip_offset+header_length+12] & 0xF0) >> 4) * 4; //mask 
    return ret;
}

unsigned short src_port(const u_char* packet, unsigned int len)
{
    assert(isIPv4(packet, len));
    int header_length = (packet[ip_offset+0] & 0x0F) * 4; //mask byte 15 with 0x0F to get header length; words * word_length
    unsigned short ret = packet[ip_offset+header_length] << 8 |
                         packet[ip_offset+header_length+1];

    return ret;
}

unsigned short dst_port(const u_char* packet, unsigned int len)
{
    assert(isIPv4(packet, len));
    int header_length = (packet[ip_offset+0] & 0x0F) * 4;
    unsigned short ret = packet[ip_offset+header_length+2] << 8 |
                         packet[ip_offset+header_length+3];
    return ret;
}

void p_stats_init(p_stats* stats)
{
    int i;

    if(names == NULL) p_stats_names_init();

    stats->total_packets = 0;
    for(i=0; i < ETHERTYPE_ENUM_SIZE; ++i)  stats->ether_stats[i]   = 0;
    for(i=0; i < IPTYPE_SIZE; ++i)          stats->ip_stats[i]      = 0;
    for(i=0; i < UDPTYPE_SIZE; ++i)         stats->udp_stats[i] = 0;
    for(i=0; i < TCPTYPE_SIZE; ++i)         stats->tcp_stats[i] = 0;
}

enum ethertype_value get_ethertype(const u_char *packet, unsigned int len)
{
    assert(len > 13);

    enum ethertype_value c1 = packet[12] & 0xff;
    enum ethertype_value c2 = packet[13] & 0xff;

    return (c1 << 8) | c2;
}

boolean isIPv4(const u_char *packet, unsigned int len)
{
    if(get_ethertype(packet, len) != IPv4) return false;
    if((packet[ip_offset+0] >> 4) != 4) return false;

    return true;
}

enum iptype_value get_protocol_ip(const u_char *packet, unsigned int len)
{
    assert(isIPv4(packet, len));
    return packet[ip_offset+9];
}

boolean mac_src_equal(int a1, int a2, int a3, int a4, int a5, int a6,
                      const u_char* packet, unsigned int len)
{
    assert(len > 11);
    if(packet[6] == a1 &&
       packet[7] == a2 &&
       packet[8] == a3 &&
       packet[9] == a4 &&
       packet[10] == a5 &&
       packet[11] == a6)
        return true;
    else
        return false;
}

boolean src_host_equal(int a1, int a2, int a3, int a4,
                       const u_char *packet, unsigned int len)
{
    assert(len > 15);
    if(packet[12] == a1 &&
       packet[13] == a2 &&
       packet[14] == a3 &&
       packet[15] == a4)
        return true;
    else
        return false;
}

boolean dst_host_equal(int a1, int a2, int a3, int a4,
                       const u_char *packet, unsigned int len)
{
    assert(len > 19);
    if(packet[16] == a1 &&
       packet[17] == a2 &&
       packet[18] == a3 &&
       packet[19] == a4)
        return true;
    else
        return false;
}


/*void update_protocol_id(int a, const u_char* packet, unsigned int len)
{
    assert(len > ip_offset+9);
    packet[ip_offset+9] = a;
}*/

/*void update_src_port(int a, qcap_packet_t* packet)
{
    int header_length = (packet->ip_packet[0] & 0x0F) * 4; //mask byte 15 with 0x0F to get header length; words * word_length
    int first_port_byte = a / 256;
    int second_port_byte = a % 256;
    packet->ip_packet[header_length] = first_port_byte;
    packet->ip_packet[header_length+1] = second_port_byte;
}*/

/*void update_dst_port(int a, qcap_packet_t* packet)
{
    int header_length = (packet->ip_packet[0] & 0x0F) * 4;
    int first_port_byte = a / 256;
    int second_port_byte = a % 256;
    packet->ip_packet[header_length+2] = first_port_byte;
    packet->ip_packet[header_length+3] = second_port_byte;
}*/

/*void update_src_host(int a1, int a2, int a3, int a4, qcap_packet_t* packet)
{
    packet->ip_packet[12] = a1;
    packet->ip_packet[13] = a2;
    packet->ip_packet[14] = a3;
    packet->ip_packet[15] = a4;
}*/


/*void update_dst_host(int a1, int a2, int a3, int a4, qcap_packet_t* packet)
{
    packet->ip_packet[16] = a1;
    packet->ip_packet[17] = a2;
    packet->ip_packet[18] = a3;
    packet->ip_packet[19] = a4;
}*/
    
    
#define ETHER_STATS(a,b) if(stats->ether_stats[b]) fprintf(a, "%-24s:%8d\n", names->ether_names[b], stats->ether_stats[b])

#define IP_STATS(a,b) if(stats->ip_stats[b]) fprintf(a, "    %-20s:%8d\n", names->ip_names[b], stats->ip_stats[b])

#define UDP_STATS(a,b) if(stats->udp_stats[b]) fprintf(a, "        %-16s:%8d\n", names->udp_names[b], stats->udp_stats[b])

#define TCP_STATS(a,b) if(stats->tcp_stats[b]) fprintf(a, "        %-16s:%8d\n", names->tcp_names[b], stats->tcp_stats[b])

#define PORTS(a,b,bl) (src_port(b,bl) == a || dst_port(b,bl) == a)

void _p_stats_print_udp(FILE* flog, p_stats* stats)
{
    int i;
    for(i=0; i < UDPTYPE_SIZE; i++)
        UDP_STATS(flog, i);
}

void _p_stats_print_tcp(FILE* flog, p_stats* stats)
{
    int i;
    for(i=0; i < TCPTYPE_SIZE; i++)
        TCP_STATS(flog, i);
}


void _p_stats_print_ip(FILE* flog, p_stats* stats)
{
    IP_STATS(flog, ICMP_E);
    IP_STATS(flog, IGMP_E);
    IP_STATS(flog, TCP_E);
        _p_stats_print_tcp(flog, stats);
    IP_STATS(flog, UDP_E);
        _p_stats_print_udp(flog, stats);
    IP_STATS(flog, EIGRP_E);
}

void p_stats_print(FILE* flog, p_stats* stats)
{
    ETHER_STATS(flog, IPv4_E);
        _p_stats_print_ip(flog, stats);
    ETHER_STATS(flog, ARP_E);
    ETHER_STATS(flog, RARP_E);
    ETHER_STATS(flog, ETHERTALK_E);
    ETHER_STATS(flog, AARP_E);
    ETHER_STATS(flog, IEEE8021Q_E);
    ETHER_STATS(flog, IPX_E);
    ETHER_STATS(flog, NOVELL_E);
    ETHER_STATS(flog, IPv6_E);
    ETHER_STATS(flog, ETHER_E);
}

void p_stats_print_summary(FILE* flog, p_stats* stats)
{
    int total_unknown = 0;
    p_stats_print(flog, stats);

    total_unknown += stats->ether_stats[ETHER_UNKNOWN_E];
    total_unknown += stats->ip_stats[IP_UNKNOWN_E];
    total_unknown += stats->udp_stats[UDP_UNKNOWN_E];
    total_unknown += stats->tcp_stats[TCP_UNKNOWN_E];

    fprintf(flog, "\nTotal Packets:         %8d\n", stats->total_packets);
    fprintf(flog, "Unknown Ethernet:      %8d (%2.2f%%)\n", stats->ether_stats[ETHER_UNKNOWN_E], (float)stats->ether_stats[ETHER_UNKNOWN_E]/stats->total_packets*100);
    fprintf(flog,   "Unknown IP:            %8d (%2.2f%%)\n", stats->ip_stats[IP_UNKNOWN_E], (float)stats->ip_stats[IP_UNKNOWN_E]/stats->total_packets*100);
    fprintf(flog,   "Unknown UDP:           %8d (%2.2f%%)\n", stats->udp_stats[UDP_UNKNOWN_E], (float)stats->udp_stats[UDP_UNKNOWN_E]/stats->total_packets*100);
    fprintf(flog,   "Unknown TCP:           %8d (%2.2f%%)\n", stats->tcp_stats[TCP_UNKNOWN_E], (float)stats->tcp_stats[TCP_UNKNOWN_E]/stats->total_packets*100);
    fprintf(flog, "\nTotal Unknown packets: %8d (%2.2f%%)\n", total_unknown, (float)total_unknown/stats->total_packets*100);
}

boolean classify_udp_exceptions(p_stats* stats, const u_char* packet,
                                unsigned int len)
{
    boolean ret = true;
    if(PORTS(8649, packet, len)) stats->udp_stats[GANGLIA_E]++;
    else                         ret = false;

    return ret;
}


boolean classify_tcp_exceptions(p_stats* stats, const u_char* packet,
                                unsigned int len)
{
    boolean ret = true;
        
//          if(PORTS(16080, packet, len))    stats->tcp_stats[TCP_EXCEPTION_1_E]++; we found these were HTTP packets running on wierd ports
      
            if(PORTS(16080, packet, len)) stats->tcp_stats[HTTP_E]++;
    else    if(PORTS(8194, packet, len)) stats->tcp_stats[TCP_SOPHOS_E]++;
//  else    if(PORTS(8206, packet, len)) stats->tcp_stats[TCP_EXCEPTION_3_E]++;
    else                                ret = false;

    return ret;
}

boolean classify_udp(p_stats* stats, const u_char* packet, unsigned int len)
{
    assert(get_ethertype(packet, len) == IPv4 &&
           get_protocol_ip(packet, len) == UDP_V);

    boolean ret = true; 
    // These should be arranged in order of frequency, from most to least
    // Should this be configured in some pluginable way?
    if(dst_host_equal(224, 0, 0, 251, packet, len))stats->udp_stats[MDNS_E]++;
    else    if(PORTS(1985, packet, len))     stats->udp_stats[HSRP_E]++;
    else    if(PORTS(513, packet, len))      stats->udp_stats[WHO_E]++;
    else    if(PORTS(427, packet, len))      stats->udp_stats[SRVLOC_E]++;
    else    if(PORTS(161, packet, len))      stats->udp_stats[SNMP_E]++;
    else    if(PORTS(520, packet, len))      stats->udp_stats[RIPv1_E]++;
    else    if(PORTS(137, packet, len))      stats->udp_stats[NBNS_E]++;
    else    if(PORTS(138, packet, len))      stats->udp_stats[NETBIOS_DGM_E]++;
//    else    if(PORTS(42, packet, len))       stats->udp_stats[AHIJAZI_E]++;
    else    if(PORTS(67, packet, len)   &&
               PORTS(68, packet, len))       stats->udp_stats[DHCP_E]++;
    else    if(PORTS(1025, packet, len) ||
               PORTS(1026, packet, len) ||
               PORTS(1027, packet, len) ||
               PORTS(1028, packet, len) ||
               PORTS(1029, packet, len) ||
               PORTS(1030, packet, len) ||
               PORTS(1031, packet, len) ||
               PORTS(1032, packet, len) ||
               PORTS(1033, packet, len))     stats->udp_stats[MSFT_MS_E]++;
    else    if(PORTS(6970, packet, len) ||  
               PORTS(6972, packet, len) ||
               PORTS(6974, packet, len) ||
               PORTS(6976, packet, len))     stats->udp_stats[RTP_E]++;
    else    if(PORTS(32459, packet, len) ||
               PORTS(13881, packet, len))    stats->udp_stats[BITTORRENT_E]++;
    else    if(PORTS(1434, packet, len))     stats->udp_stats[MSFT_SQL_E]++;
    else    if(PORTS(53, packet, len))       stats->udp_stats[UDP_DNS_E]++;
    else    if(PORTS(123, packet, len))      stats->udp_stats[NTP_E]++;
    else    if(PORTS(631, packet, len))      stats->udp_stats[CUPS_E]++;
    else    if(PORTS(177, packet, len))      stats->udp_stats[XDMCP_E]++;
    else    if(PORTS(500, packet, len))      stats->udp_stats[IPSEC_E]++;
    else    if(classify_udp_exceptions(stats, packet, len)) { }
    else
    {
    //    fprintf(stderr, "Unknown UDP protocol in packet %d: src/dst: %d/%d.\n",
    //                    total_packets, src_port(packet), dst_port(packet));
        ret = false;
        stats->udp_stats[UDP_UNKNOWN_E]++;
    //    exit(0);
    }

    return ret;
}

boolean classify_tcp(p_stats* stats, const u_char* packet, unsigned int len)
{
    assert(get_ethertype(packet, len) == IPv4 &&
           get_protocol_ip(packet, len) == TCP_V);
    boolean ret = true;
// look for TCP special size packets before exploring what port they deal with
    if(ip_total_length(packet, len) ==
       ip_header_length(packet, len) + tcp_header_length(packet, len)) 
                                            stats->tcp_stats[TCP_SPECIAL_LEN_E]++; //TCP packets with no payload (headers only)
    else    if(PORTS(80, packet, len))      stats->tcp_stats[HTTP_E]++;
    else    if(PORTS(443, packet, len))     stats->tcp_stats[HTTPS_E]++;
    else    if(PORTS(110, packet, len))     stats->tcp_stats[POP_E]++;
    else    if(PORTS(995, packet, len))     stats->tcp_stats[POPS_E]++;
    else    if(PORTS(22, packet, len))      stats->tcp_stats[SSH_E]++;
    else    if(PORTS(25, packet, len))      stats->tcp_stats[SMTP_E]++;
    else    if(PORTS(23, packet, len))      stats->tcp_stats[TELNET_E]++;
    else    if(PORTS(445, packet, len))     stats->tcp_stats[SMB_E]++;
    else    if(PORTS(135, packet, len))     stats->tcp_stats[DCE_RPC_E]++;
    else    if(PORTS(631, packet, len))     stats->tcp_stats[IPP_E]++;
    else    if(PORTS(1863, packet, len))    stats->tcp_stats[MSNMS_E]++;
    else    if(PORTS(139, packet, len))     stats->tcp_stats[NBSS_E]++;
    else    if(PORTS(554, packet, len))     stats->tcp_stats[RTSP_E]++;
    else    if(PORTS(53, packet, len))      stats->tcp_stats[TCP_DNS_E]++;
    else    if(PORTS(20, packet, len) ||
               PORTS(21, packet, len))      stats->tcp_stats[FTP_E]++;
    else    if(PORTS(6667, packet, len))    stats->tcp_stats[IRC_E]++;
//  else    if(PORTS(3306, packet, len))    stats->tcp_stats[SUNRPC_E]++;
    else    if(PORTS(111, packet, len))     stats->tcp_stats[MYSQL_E]++;
    else    if(PORTS(5222, packet, len))    stats->tcp_stats[XMPP_E]++;
    else    if(PORTS(119, packet, len))     stats->tcp_stats[NNTP_E]++;
    else    if(PORTS(465, packet, len))     stats->tcp_stats[URD_E]++;
    else    if(PORTS(2401, packet, len))    stats->tcp_stats[CVS_E]++;
    else    if(PORTS(3389, packet, len))    stats->tcp_stats[MSFT_WBT_E]++;
    else    if(PORTS(143, packet, len))     stats->tcp_stats[IMAP_E]++;
    else    if(PORTS(993, packet, len))     stats->tcp_stats[IMAPS_E]++;
    else    if(PORTS(1755, packet, len))    stats->tcp_stats[MS_STREAMING_E]++;
    else    if(classify_tcp_exceptions(stats, packet, len)) { }
    else {                                  stats->tcp_stats[TCP_UNKNOWN_E]++;
                                            ret = false; }
    return ret;
}

boolean classify_ip(p_stats* stats, const u_char* packet, unsigned int len)
{
    assert(get_ethertype(packet, len) == IPv4);
    boolean ret = true;

    enum iptype_value type = get_protocol_ip(packet, len);
    switch(type)
    {
        case ICMP_V:    stats->ip_stats[ICMP_E]++;               break;
        case IGMP_V:    stats->ip_stats[IGMP_E]++;               break;
        case TCP_V:     stats->ip_stats[TCP_E]++;     
                        ret = classify_tcp(stats, packet, len);  break;
        case UDP_V:     stats->ip_stats[UDP_E]++;   
                        ret = classify_udp(stats, packet, len);  break;
        case EIGRP_V:   stats->ip_stats[EIGRP_E]++;              break;
        
        default:
            ret = false;
            stats->ip_stats[IP_UNKNOWN_E]++;
    }
    return ret;
}

boolean classify(p_stats* stats, const u_char* packet, unsigned int len)
{
    enum ethertype_value type = get_ethertype(packet, len);
    boolean ret = true;

    stats->total_packets++;

    switch(type)
    {
        case IPv4:          stats->ether_stats[IPv4_E]++;         
                            ret = classify_ip(stats, packet, len);      break;
        case ARP:           stats->ether_stats[ARP_E]++;                break;
        case RARP:          stats->ether_stats[RARP_E]++;               break;
        case ETHERTALK:     stats->ether_stats[ETHERTALK_E]++;          break;
        case AARP:          stats->ether_stats[AARP_E]++;               break;
        case IEEE8021Q:     stats->ether_stats[IEEE8021Q_E]++;          break;
        case IPX:           stats->ether_stats[IPX_E]++;                break;
        case NOVELL:        stats->ether_stats[NOVELL_E]++;             break;
        case IPv6:          stats->ether_stats[IPv6_E]++;               break;
        case 0 ... 1500:    stats->ether_stats[ETHER_E]++;              break;
        case ETHER_EXCEPTION_1:
                            stats->ether_stats[ETHER_EXCEPTION_1_E]++;  break;

        default:
            ret = false;
            stats->ether_stats[ETHER_UNKNOWN_E]++;
    }

    return ret;
}

void p_stats_total(p_stats* total, p_stats* stats, int count)
{
    int i, j;
    for(i=0; i < count; i++)
    {
        total->total_packets += stats[i].total_packets;
        for(j=0; j < ETHERTYPE_ENUM_SIZE; j++)
            total->ether_stats[j] += stats[i].ether_stats[j];

        for(j=0; j < IPTYPE_SIZE; j++)
            total->ip_stats[j] += stats[i].ip_stats[j];

        for(j=0; j < UDPTYPE_SIZE; j++)
            total->udp_stats[j] += stats[i].udp_stats[j];

        for(j=0; j < TCPTYPE_SIZE; j++)
            total->tcp_stats[j] += stats[i].tcp_stats[j];
    }
}

int p_stats_count_protocols(p_stats* stats)
{
    int ret = 0;
    int i;

    if(stats->ip_stats[TCP_E])
        for(i=0; i < TCPTYPE_SIZE; i++)
            if(stats->tcp_stats[i] > 0) ret++;

    if(stats->ip_stats[UDP_E])
        for(i=0; i < UDPTYPE_SIZE; i++)
            if(stats->udp_stats[i] > 0) ret++;

    if(stats->ether_stats[IPv4_E])
        for(i=0; i < IPTYPE_SIZE; i++)
            if(i != UDP_E && i != TCP_E && stats->ip_stats[i] > 0) ret++;

    for(i=0; i < ETHERTYPE_ENUM_SIZE; i++)
        if(i != IPv4_E && stats->ether_stats[i] > 0) ret++;

    return ret;
}

boolean p_stats_test_mono(p_stats* stats)
{
    int ret = 0;
    int i;
    for(i=0; i < ETHERTYPE_ENUM_SIZE; i++)
        if(stats->ether_stats[i] > 0 ) ret++;

    if(ret > 1 ) return false; 
    ret = 0;

    if(stats->ether_stats[IPv4_E])
        for(i=0; i < IPTYPE_SIZE; i++)
            if(stats->ip_stats[i] > 0) ret++;

    if(ret > 1) return false;
    ret = 0;

    if(stats->ip_stats[UDP_E])
        for(i=0; i < UDPTYPE_SIZE; i++)
            if(stats->udp_stats[i] > 0) ret++;

    if(ret > 1) return false;

    if(stats->ip_stats[TCP_E])
        for(i=0; i < TCPTYPE_SIZE; i++)
            if(stats->tcp_stats[i] > 0) ret++;

    if(ret > 1) return false; 

    return true;
}

int p_stats_protocols_count_mono_packets(p_stats* stats)
{
    int i;

    if(p_stats_test_mono(stats))
    {
        for(i=0; i < ETHERTYPE_ENUM_SIZE; i++)
            if(stats->ether_stats[i] > 0 && i != IPv4) return stats->ether_stats[i];

        for(i=0; i < IPTYPE_SIZE; i++)
            if(stats->ip_stats[i] > 0 && (i != TCP_E || i != UDP_E)) return stats->ip_stats[i];

        for(i=0; i < UDPTYPE_SIZE; i++)
            if(stats->udp_stats[i] > 0) return stats->udp_stats[i];

        for(i=0; i < TCPTYPE_SIZE; i++)
            if(stats->tcp_stats[i] > 0) return stats->tcp_stats[i];
    }

    return 0;
}


// ------------------------------------------------------------------

#include"palette.h"

int print_arc(
    char* buffer,
    float r, float g, float b,
    float radius,
    float start, float end,
    boolean filled)
{
    char* tmp = buffer;
    tmp += sprintf(tmp, "newpath\n");
    tmp += sprintf(tmp, "%.2f %.2f %.2f setrgbcolor\n", r, g, b);
    tmp += sprintf(tmp, "0.2 setlinewidth\n");
    tmp += sprintf(tmp, "0 0 moveto\n");
    tmp += sprintf(tmp, "0 0 %.2f %.2f %.2f arc\n", radius, start, end);
    tmp += sprintf(tmp, "closepath %s\n\n", filled ? "fill" : "stroke");

    return (tmp - buffer);
}

int print_outlined_arc(
    char* buffer,
    float r, float g, float b,
    float radius,
    float start, float end)
{
    char* tmp = buffer;
    tmp += print_arc(tmp, r, g, b, radius, start, end, true);
    tmp += print_arc(tmp, 0, 0, 0, radius, start, end, false);

    return (tmp - buffer);
}

int print_circle(
    char* buffer,
    float r, float g, float b,
    float radius,
    boolean filled)
{
    char* tmp = buffer;
    tmp += sprintf(tmp, "newpath\n");
    tmp += sprintf(tmp, "%.2f %.2f %.2f setrgbcolor\n", r, g, b);
    tmp += sprintf(tmp, "0.2 setlinewidth\n");
    tmp += sprintf(tmp, "0 0 %.2f 0 360 arc\n", radius);
    tmp += sprintf(tmp, "closepath %s\n\n", filled ? "fill" : "stroke");

    return (tmp - buffer);
}

#define COLOR(a) palette[a].r, palette[a].g, palette[a].b
#define BLACK 0, 0, 0
#define WHITE 1, 1, 1

int print_outlined_circle(
    char* buffer,
    float r, float g, float b,
    float radius)
{
    char* tmp = buffer;
    tmp += print_circle(buffer, r, g, b, radius, true);
    tmp += print_circle(buffer, 0, 0, 0, radius, false);
}



char* p_stats_print_pie_chart(p_stats* stats, int radius)
{
    char* buffer = (char*)malloc(sizeof(char)*1024*32);
    char* tmp = buffer;

    int length_x = radius*2;
    int length_y = radius*2;

    int i;
    
    float start = 90;

    float ether_starts[ETHERTYPE_ENUM_SIZE];
    float ether_ends[ETHERTYPE_ENUM_SIZE];

    float ip_starts[IPTYPE_SIZE];
    float ip_ends[IPTYPE_SIZE];

    boolean mono = p_stats_test_mono(stats);

    for(i=0; i < ETHERTYPE_ENUM_SIZE; i++)
    {
        ether_starts[i] = 0;
        ether_ends[i] = 0;
    }

    for(i=0; i < IPTYPE_SIZE; i++)
    {
        ip_starts[i] = 0;
        ip_ends[i] = 0;
    }

    tmp += sprintf(tmp, "%%%%!PS-Adobe EPSF-3.0\n");
    tmp += sprintf(tmp, "%%%%BoundingBox: 0 0 %d %d\n", length_x, length_y);
    tmp += sprintf(tmp, "%%%%EndComments\n");
    tmp += sprintf(tmp, "%d %d translate\n", radius, radius);

    if(mono)
    {
        float r = 0.25 * radius;
        tmp += sprintf(tmp, "newpath\n");
        tmp += sprintf(tmp, "0 0 0 setrgbcolor\n");
        tmp += sprintf(tmp, "0.2 setlinewidth\n");
        tmp += sprintf(tmp, "%d 0 moveto\n", radius);
        tmp += sprintf(tmp, "%d %d -%d %d %f arct\n", radius, radius, radius, radius, r); 
        tmp += sprintf(tmp, "-%d %d -%d -%d %f arct\n", radius, radius, radius, radius, r);
        tmp += sprintf(tmp, "-%d -%d %d -%d %f arct\n", radius, radius, radius, radius, r);
        tmp += sprintf(tmp, "%d -%d %d 0 %f arct\n", radius, radius, radius, r);
        tmp += sprintf(tmp, "closepath\ngsave\n0.6 setgray\nfill\n");
        tmp += sprintf(tmp, "grestore\n 0.2 setlinewidth\nstroke\nshowpage\n");
        tmp += sprintf(tmp, "closepath stroke\n");

    }

    // Ethertype pie chart
    for(i=0; i < ETHERTYPE_ENUM_SIZE; i++)
    {
        float percentage = (float)stats->ether_stats[i]/
                           (float)stats->total_packets;


        if(percentage > 0)
        {
            float end   = start + (percentage * 360);
            //if(mono)
            if(false)
                tmp += print_outlined_circle(tmp, COLOR(i), radius);
            else
                tmp += print_outlined_arc(tmp, COLOR(i), radius, start, end);

            ether_starts[i] = start;
            ether_ends[i] = end;

            start = end;
        }
    }

    // IP pie chart
    float ip_start = ether_starts[IPv4_E];
    float ip_end   = ether_ends[IPv4_E];
    float ip_range = ip_end - ip_start;
    start = ip_start;
    for(i=0; i < IPTYPE_SIZE; i++)
    {
        float percentage = (float)stats->ip_stats[i]/
                           (float)stats->ether_stats[IPv4_E];

        if(percentage > 0)
        {
            float end = start + percentage*ip_range;
            //if(mono)
            if(false)
                tmp += print_outlined_circle(tmp, COLOR(i), radius-4);
            else
                tmp += print_outlined_arc(tmp, COLOR(i), radius-4, start, end);

            ip_starts[i] = start;
            ip_ends[i] = end;

            start = end;
        }
    }

    // UDP pie chart
    float udp_start = ip_starts[UDP_E];
    float udp_end   = ip_ends[UDP_E];
    float udp_range = udp_end - udp_start;
    start = udp_start;
    for(i=0; i < UDPTYPE_SIZE; i++)
    {
        float percentage = (float)stats->udp_stats[i]/
                           (float)stats->ip_stats[UDP_E];

        if(percentage > 0)
        {
            float end = start + percentage*udp_range;
            //if(mono)
            if(false)
                tmp += print_outlined_circle(tmp, COLOR(i), radius-8);
            else
                tmp += print_outlined_arc(tmp, COLOR(i), radius-8, start, end);

            start = end;
        }
    }

    // TCP pie chart
    float tcp_start = ip_starts[TCP_E];
    float tcp_end   = ip_ends[TCP_E];
    float tcp_range = tcp_end - tcp_start;
    start = tcp_start;
    for(i=0; i < TCPTYPE_SIZE; i++)
    {
        float percentage = (float)stats->tcp_stats[i]/
                           (float)stats->ip_stats[TCP_E];

        if(percentage > 0)
        {
            float end = start + percentage*tcp_range;
            //if(mono)
            if(false)
                tmp += print_outlined_circle(tmp, COLOR(i), radius-8);
            else
                tmp += print_outlined_arc(tmp, COLOR(i), radius-8, start, end);

            start = end;
        }
    }

    tmp += sprintf(tmp, "%%%%EOF\n");
    return buffer;
}

int f2h(float val)
{
    return (int)(val*255);
}

#define ETHER_KEY1(index) fprintf(fgraph, \
"    ETHER1%d [style=filled label=\"%s\" color=\"#%02x%02x%02x\" shape=rectangle height=0.7 width=1.7 ] \n    ROOT->ETHER1%d [color=white]\n",  \
index, names->ether_names[index], f2h(palette[index].r), f2h(palette[index].g), f2h(palette[index].b), index)

#define IP_KEY1(index) fprintf(fgraph, \
"    IP1%d [style=filled label=\"%s\" color=\"#%02x%02x%02x\" shape=rectangle height=0.7 width=1.7 ]\n    ETHER1%d->IP1%d [color=white]\n", \
index, names->ip_names[index], f2h(palette[index].r), f2h(palette[index].g), f2h(palette[index].b), index, index)

#define TCP_KEY1(index) fprintf(fgraph, \
"    TCP1%d [style=filled label=\"%s\" color=\"#%02x%02x%02x\" shape=rectangle height=0.7 width=1.7 ]\n    IP1%d->TCP1%d [color=white]\n", \
index, names->tcp_names[index], f2h(palette[index].r), f2h(palette[index].g), f2h(palette[index].b), index, index)

#define UDP_KEY1(index) fprintf(fgraph, \
"    UDP1%d [style=filled label=\"%s\" color=\"#%02x%02x%02x\" shape=rectangle height=0.7 width=1.7 ]\n    TCP1%d->UDP1%d [color=white]\n", \
index, names->udp_names[index], f2h(palette[index].r), f2h(palette[index].g), f2h(palette[index].b), index, index)

#define ETHER_KEY2(index) fprintf(fgraph, \
"    ETHER2%d [style=filled label=\"%s\" color=\"#%02x%02x%02x\" shape=rectangle height=0.7 width=1.7 ] \n    UDP1%d->ETHER2%d [color=white]\n",  \
index, names->ether_names[index], f2h(palette[index].r), f2h(palette[index].g), f2h(palette[index].b), index -15, index)

#define IP_KEY2(index) fprintf(fgraph, \
"    IP2%d [style=filled label=\"%s\" color=\"#%02x%02x%02x\" shape=rectangle height=0.7 width=1.7 ]\n    ETHER2%d->IP2%d [color=white]\n", \
index, names->ip_names[index], f2h(palette[index].r), f2h(palette[index].g), f2h(palette[index].b), index, index)

#define TCP_KEY2(index) fprintf(fgraph, \
"    TCP2%d [style=filled label=\"%s\" color=\"#%02x%02x%02x\" shape=rectangle height=0.7 width=1.7 ]\n    IP2%d->TCP2%d [color=white]\n", \
index, names->tcp_names[index], f2h(palette[index].r), f2h(palette[index].g), f2h(palette[index].b), index, index)

#define UDP_KEY2(index) fprintf(fgraph, \
"    UDP2%d [style=filled label=\"%s\" color=\"#%02x%02x%02x\" shape=rectangle height=0.7 width=1.7 ]\n    TCP2%d->UDP2%d [color=white]\n", \
index, names->udp_names[index], f2h(palette[index].r), f2h(palette[index].g), f2h(palette[index].b), index, index)

void p_stats_print_key(FILE* fgraph)
{
    int i;
    p_stats dummy;
    if(names == NULL) p_stats_init(&dummy);

    fprintf(fgraph, "digraph KEY {\n");
    fprintf(fgraph, "    ROOT [style=filled label=\"\" color=white shape=rectangle]\n");

    for(i=0; i < ETHERTYPE_ENUM_SIZE/2; i++)
        ETHER_KEY1(i);

    for(i=0; i < IPTYPE_SIZE/2; i++)
        IP_KEY1(i);

    for(i=0; i < TCPTYPE_SIZE/2; i++)
        TCP_KEY1(i);

    for(i=0; i < UDPTYPE_SIZE/2; i++)
        UDP_KEY1(i);

    for(i= ETHERTYPE_ENUM_SIZE/2; i < ETHERTYPE_ENUM_SIZE; i++)
        ETHER_KEY2(i);

    for(i= IPTYPE_SIZE/2; i < IPTYPE_SIZE; i++)
        IP_KEY2(i);

    for(i= TCPTYPE_SIZE/2; i < TCPTYPE_SIZE; i++)
        TCP_KEY2(i);

    for(i= UDPTYPE_SIZE/2; i < UDPTYPE_SIZE; i++)
        UDP_KEY2(i);

    fprintf(fgraph, "}\n");
}
