#include<math.h>
#include"sim.h"
//#include"hashtable.h"
//#include"hashtable_itr.h"
#include"cache.h"
#include"constants.h"
#include"stats.h"
#include"protocol.h"

int pie_wedges(int size, int* array)
{
    boolean only = true;
    int ret = -1;
    int i;
    for(i=0; i < size; i++)
        if(array[i] > 0)
            if(only == false)
                return -1;
            else
            { ret = i; only = false; }

    return ret;
}


/* Commented out due to removing hashtable_t* dependency
unsigned int packfn(void* val)
{
    assert(val != NULL);
    qcap_packet_t* packet = (qcap_packet_t*)val;
    int length = packet->ip_len;
    unsigned int hash = 0;
    int i;

    for(i=0; i < length; i++)
        hash = packet->ip_packet[i] + (hash << 6) + (hash << 16) - hash;

    return hash;
}

int packeqn(void* packet1, void* packet2)
{
    assert(packet1 != NULL && packet2 != NULL); 
    qcap_packet_t* p1 = (qcap_packet_t*)packet1; 
    qcap_packet_t* p2 = (qcap_packet_t*)packet2; 

    int i;
    u_char* pc1, *pc2;
    if (p1->ip_len != p2->ip_len) return false;

    pc1 = p1->ip_packet;
    pc2 = p2->ip_packet;
    for(i=0; i < p1->ip_len; i++)
        if( pc1[i] != pc2[i] )
            return false;

    return true;
}

struct hashtable* hashtable_from_packets(int size, qcap_packet_t* packets[])
{
    int i;
    struct hashtable* hash = create_hashtable(4001, packfn, packeqn);
    for(i=0; i < size; i++)
    {
        int* val;
        if((val = hashtable_search(hash, packets[i])) == NULL)
        {
            val = (int*)malloc(sizeof(int));
            (*val) = 1;
            if(!hashtable_insert(hash, packets[i], val))
            {
                fprintf(stdout, "HASHTABLE INSERT FAILED!\n");
                exit(1);
            }
        }
        else
        {
            (*val)++;
        }
    }

    return hash;
}

float entropy(int size, qcap_packet_t* packets[])
{
    int i;
    float sum=0;

    struct hashtable* hash = hashtable_from_packets(size, packets);

    if(hashtable_count(hash) > 0)
    {
        struct hashtable_itr* itr = hashtable_iterator(hash);
        boolean found = false;
        int total = size;
        int* val;

        do
        {
            int i;
            float tmp;
            qcap_packet_t* packet = hashtable_iterator_key(itr);
            val = hashtable_iterator_value(itr);

            tmp = (float)(*val)/total;
            sum += tmp*logf(tmp)/logf(2);

        }while(hashtable_iterator_advance(itr));
        free(itr);
    }

    hashtable_destroy(hash, false, false);
    sum = -1*sum;
    return(sum);
}
*/

int hamming(char* str1, int size1, char* str2, int size2)
{
    int size = min(size1,size2); 
    int distance = 8 * abs(size1 - size2);  // 8 bits * size difference
    int i;

    for(i=0; i < size; i++)
    {
        u_char c1 = str1[i], c2 = str2[i], xor = c1 ^ c2;
        int j;

        for(j=0; j < 8; j++)
        {
            distance += (xor & 0x1);
            xor = (xor >> 1);
        }
    }
    return distance;
}

/*
int* counts_by_protocol(node_t* queue)
{
    int i;
    int* ret = (int*)malloc(sizeof(int)*PTYPE_SIZE);

    for(i=0; i < PTYPE_SIZE; i++) ret[i] = 0;

    for(i=0; i < cache->size; i++)
    {
        cache_entry_t* entry = cache->cache[i];
        if(entry != NULL && entry->queue == NODE2QUEUE(queue))
        {
            ret[classify(entry->packet)]++;
        }
    }

    return ret;
}
*/

int queue_protocol_count(node_t* queue)
{
/*
    int* counts = counts_by_protocol(queue);
    int i;
    int sum = 0;
    for(i=0; i < PTYPE_SIZE; i++)
        if(counts[i] > 0)
            sum++;
    free(counts);
    return sum;
*/

    return 0;
}


