#include"constants.h"
#include"vector.h"
#include<stdlib.h>

#define JIM_VECTOR_CAPACITY 16

jim_vector_t* jim_vector_create()
{
    jim_vector_t* ret = (jim_vector_t*)malloc(sizeof(jim_vector_t));

    ret->item = (void**)malloc(sizeof(void*)*JIM_VECTOR_CAPACITY);
    ret->size = 0;
    ret->capacity= JIM_VECTOR_CAPACITY;

    return ret;
}

static void _vector_increase_capacity(jim_vector_t* vector)
{
    void** old = vector->item;
    int i;

    vector->capacity = vector->capacity*2;

    vector->item = (void**)malloc(sizeof(void*)*vector->capacity);
    for(i=0; i < vector->size; i++)
        vector->item[i] = old[i];

    free(old);
}

boolean jim_vector_add(jim_vector_t* vector, void* item)
{
    if(vector->size == vector->capacity)
        _vector_increase_capacity(vector);

    vector->item[vector->size++] = item;
}

boolean jim_vector_remove(jim_vector_t* vector, void* item)
{
    int i;
    boolean found = false;

    for(i=0; i < vector->size; i++)
        if(vector->item[i] == item) { found = true; break; }
  
    if(!found) return false;


    for(; i < vector->size; i++)
        vector->item[i] = vector->item[i+1];

    vector->size--;

    return true;
}

int jim_vector_size(jim_vector_t* vector)
{
    return vector->size;
}
