# LabelAssignments are assignments of Labels to p,n-grams and a final traffic
# classification
class LabelAssignment < ActiveRecord::Base

  # Create a new LabelAssignment for a requested classification. p,n-grams are
  # associated with this LabelAssignment later
  # @param label The ID of the label which is being used
  # @param classification The ID of the classification which is being assigned
  #                       to the label
  # @return Returns the ID of the new LabelAssignment
  def self.create_assignment(label, classification)
    l = self.new
    l.label_id = label
    l.classification_id = classification
    if l.save
      l.id
    else nil
    end
  end
end
