# A View is a non-database-model which represents a time period which the user
# wishes to view.  It can be absolute or relative.
class View
  # True if the view is absolute, false if relative
  attr :abs, true

  # The absolute time for the end of the view period (a Time object)
  attr :abs_to_time, true

  # The relative time for the end of the view period (number of seconds away
  # from the ever-changing "now")
  attr :rel_to_time, true

  # The number of seconds to view up to the end of the view period (the
  # length)
  attr :duration, true

  # Create a new View and initialize it
  # @param abs True if the new View should be absolute and false otherwise
  def initialize(abs)
    @abs = abs
    @abs_to_time = Time.new.getgm
    @rel_to_time = 0
    @duration = 0
  end
end
