class CreateInternalNodes < ActiveRecord::Migration
  def self.up
    # position is 1-based index into the tree. children are position*2 and
    #   position*2+1 from their parent.
    #   there is no guarantee of continuity of numbers if the tree is not
    #   complete.
    # p, and n are the (p,n)-gram
    execute %{CREATE TABLE internal_nodes
              (id              INT UNSIGNED NOT NULL AUTO_INCREMENT,
               revision_id     INT UNSIGNED NOT NULL,
               position        INT UNSIGNED NOT NULL,
               PRIMARY KEY(id),
               CONSTRAINT rev_position UNIQUE KEY(revision_id, position),
               FOREIGN KEY (revision_id) REFERENCES revisions(id)
               ON DELETE CASCADE)
              ENGINE=InnoDB}
  end

  def self.down
    execute 'DROP TABLE internal_nodes'
  end
end
