# This file is autogenerated. Instead of editing this file, please use the
# migrations feature of ActiveRecord to incrementally modify your database, and
# then regenerate this schema definition.

ActiveRecord::Schema.define(:version => 18) do

  create_table "capture_requests", :force => true do |t|
    t.column "tree_id", :integer, :limit => 10, :null => false
    t.column "node_id", :integer, :limit => 10, :null => false
  end

  add_index "capture_requests", ["tree_id"], :name => "tree_id"

  create_table "captures", :force => true do |t|
    t.column "capture_id", :integer, :limit => 10,    :null => false
    t.column "sequence",   :integer, :limit => 64,    :null => false
    t.column "data",       :binary,  :limit => 12000, :null => false
  end

  add_index "captures", ["capture_id", "sequence"], :name => "capture_id", :unique => true

  create_table "classifications", :force => true do |t|
    t.column "label", :string,  :limit => 100, :null => false
    t.column "ring",  :integer, :limit => 3,   :null => false
    t.column "color", :string,  :limit => 7,   :null => false
  end

  add_index "classifications", ["label"], :name => "label", :unique => true

  create_table "internal_nodes", :force => true do |t|
    t.column "node_id",     :integer, :limit => 10, :null => false
    t.column "revision_id", :integer, :limit => 10, :null => false
    t.column "position",    :integer, :limit => 10, :null => false
  end

  add_index "internal_nodes", ["revision_id", "position"], :name => "rev_position", :unique => true

  create_table "label_assignments", :force => true do |t|
    t.column "label_id",          :integer, :limit => 10, :null => false
    t.column "classification_id", :integer, :limit => 10, :null => false
  end

  add_index "label_assignments", ["classification_id"], :name => "classification_id"
  add_index "label_assignments", ["label_id"], :name => "label_id"

  create_table "label_pngrams", :force => true do |t|
    t.column "label_assignment_id", :integer, :limit => 10, :null => false
    t.column "pngram_id",           :integer, :limit => 10, :null => false
    t.column "has_pngram",          :boolean,               :null => false
  end

  add_index "label_pngrams", ["pngram_id"], :name => "pngram_id"
  add_index "label_pngrams", ["label_assignment_id"], :name => "label_assignment_id"

  create_table "labels", :force => true do |t|
    t.column "tree_id", :integer, :limit => 10,  :null => false
    t.column "name",    :string,  :limit => 100, :null => false
    t.column "color",   :string,  :limit => 7,   :null => false
  end

  add_index "labels", ["name"], :name => "name", :unique => true
  add_index "labels", ["tree_id"], :name => "tree_id"

  create_table "node_pngrams", :force => true do |t|
    t.column "internal_node_id", :integer, :limit => 10, :null => false
    t.column "pngram_id",        :integer, :limit => 10, :null => false
  end

  add_index "node_pngrams", ["pngram_id"], :name => "pngram_id"
  add_index "node_pngrams", ["internal_node_id"], :name => "internal_node_id"

  create_table "pngrams", :force => true do |t|
    t.column "p", :integer, :limit => 10,  :null => false
    t.column "n", :binary,  :limit => 255
  end

  add_index "pngrams", ["p", "n"], :name => "p", :unique => true

  create_table "revisions", :force => true do |t|
    t.column "tree_id",       :integer,  :limit => 10,                    :null => false
    t.column "revision",      :datetime,                                  :null => false
    t.column "queue_counter", :integer,  :limit => 10, :default => 10000, :null => false
    t.column "png_counter",   :integer,  :limit => 10, :default => 0,     :null => false
  end

  add_index "revisions", ["tree_id", "revision"], :name => "tree_id", :unique => true

  create_table "terminal_nodes", :force => true do |t|
    t.column "node_id",     :integer, :limit => 10, :null => false
    t.column "revision_id", :integer, :limit => 10, :null => false
    t.column "position",    :integer, :limit => 10, :null => false
  end

  add_index "terminal_nodes", ["revision_id", "position"], :name => "rev_position", :unique => true

  create_table "traffic", :force => true do |t|
    t.column "terminal_node_id",            :integer, :limit => 10,                :null => false
    t.column "ether",                       :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_mpls_uni",              :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_mpls_multi",            :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_pppoe_disc",            :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_pppoe_ss",              :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_exception_1",           :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_loop",                  :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_arp",                   :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_rarp",                  :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ethertalk",             :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_aarp",                  :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_802_1q",                :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipx",                   :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_novell",                :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv6",                  :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ataoe",                 :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ether_old",             :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4",                  :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_icmp",             :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_igmp",             :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_eigrp",            :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_udp",              :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_udp_hsrp",         :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_udp_who",          :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_udp_srvloc",       :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_udp_snmp",         :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_udp_rip_v1",       :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_udp_nbns",         :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_udp_nbdgm",        :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_udp_dce_rpc",      :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_udp_ms_sql",       :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_udp_dns",          :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_udp_ntp",          :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_udp_dhcp",         :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_udp_mdns",         :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_udp_rtp",          :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_udp_cups",         :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_udp_xdmcp",        :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_udp_torrent",      :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_udp_ganglia",      :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_udp_ipsec",        :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_tcp",              :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_tcp_http",         :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_tcp_https",        :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_tcp_telnet",       :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_tcp_imap",         :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_tcp_imaps",        :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_tcp_smtp",         :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_tcp_ipp",          :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_tcp_nbss",         :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_tcp_ssh",          :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_tcp_pop",          :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_tcp_pops",         :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_tcp_msnms",        :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_tcp_smb",          :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_tcp_dns",          :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_tcp_ftp",          :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_tcp_rtsp",         :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_tcp_irc",          :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_tcp_mysql",        :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_tcp_nntp",         :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_tcp_dce_rpc",      :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_tcp_xmpp",         :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_tcp_no_payload",   :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_tcp_tcp_sophos",   :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_tcp_ms_streaming", :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_tcp_urd",          :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_tcp_cvs",          :integer, :limit => 10, :default => 0, :null => false
    t.column "ether_ipv4_tcp_ms_wbt",       :integer, :limit => 10, :default => 0, :null => false
  end

  add_index "traffic", ["terminal_node_id"], :name => "terminal_node_id", :unique => true

  create_table "trees", :force => true do |t|
    t.column "tree_name", :string, :null => false
  end

end
